/// <reference types="prosemirror-model" />
import { SpecRegistry } from '@bangle.dev/core';
import type { Command, Schema } from '@bangle.dev/pm';
import { PluginKey } from '@bangle.dev/pm';
import type { SuggestTooltipRenderOpts } from '@bangle.dev/tooltip';
import { EmojiGroupType } from './types';
export declare const spec: typeof specFactory;
export declare const plugins: typeof pluginsFactory;
export declare const commands: {
    queryTriggerText: typeof queryTriggerText;
    selectEmoji: typeof selectEmoji;
};
declare function specFactory({ markName, trigger, }: {
    markName: string;
    trigger?: string;
}): {
    options: {
        trigger: string;
    };
    name: string;
    type: string;
    schema: {
        inclusive: boolean;
        group: string;
        parseDOM: {
            tag: string;
        }[];
        toDOM: (node: import("prosemirror-model").Node<any>) => (string | {
            'data-bangle-name': string;
            'data-suggest-trigger': any;
            style: string;
        })[];
        attrs: {
            trigger: {
                default: string;
            };
        };
    };
    markdown: {
        toMarkdown: {
            open: string;
            close: string;
            mixable: boolean;
        };
    };
};
export declare type GetEmojiGroupsType = (queryText: string) => EmojiGroupType;
declare function pluginsFactory({ key, markName, tooltipRenderOpts, getEmojiGroups, maxItems, squareSide, squareMargin, rowWidth, palettePadding, }: {
    markName: string;
    key?: PluginKey;
    tooltipRenderOpts?: SuggestTooltipRenderOpts;
    getEmojiGroups: GetEmojiGroupsType;
    maxItems?: number;
    squareSide?: number;
    squareMargin?: number;
    rowWidth?: number;
    palettePadding?: number;
}): ({ schema, specRegistry, }: {
    schema: Schema;
    specRegistry: SpecRegistry;
}) => (import("prosemirror-state").Plugin<any, any> | (({ schema }: {
    schema: Schema<any, any>;
}) => any[]))[];
export declare function getSuggestTooltipKey(key: PluginKey): any;
export declare function queryTriggerText(key: PluginKey): (state: import("prosemirror-state").EditorState<any>) => string;
export declare function selectEmoji(key: PluginKey, emojiAlias: string): Command;
export {};
//# sourceMappingURL=emoji-suggest.d.ts.map